// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S208_AddPartitionsToReferences.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S208_AddPartitionsToReferences extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int convertPartitionAscState = 4;
  public static final int convertPartitionDescState = 6;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3, 3
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\5\2\0\2\6"+
    "\1\0\1\7\12\10\1\11\1\12\5\0\1\13\1\14"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\22"+
    "\1\24\1\25\1\26\1\27\1\30\1\31\1\22\1\32"+
    "\1\33\1\34\1\35\1\36\1\37\2\22\1\40\1\41"+
    "\1\0\1\42\1\0\1\43\1\0\1\44\1\45\1\46"+
    "\1\47\1\50\1\51\1\52\1\0\1\53\1\0\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\0\1\62\1\63"+
    "\1\64\1\65\1\66\1\67\2\0\1\70\265\0\2\53"+
    "\115\0\1\63\u0182\0\1\1\20\0\2\6\u0115\0\1\54"+
    "\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\4\0\2\1\2\2\3\3\15\0\1\4\120\0\1\5"+
    "\36\0\1\5\71\0\1\6\6\0\1\5\6\0\1\5"+
    "\5\0\1\6\70\0\2\7\u01d0\0\1\10\1\0\1\11"+
    "\5\0\1\12\2\0\1\13\155\0\1\14\2\0\1\15"+
    "\155\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[971];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\71\0\162\0\253\0\344\0\u011d\0\344\0\u0156"+
    "\0\344\0\u018f\0\u01c8\0\u0201\0\u023a\0\u0273\0\u02ac\0\u02e5"+
    "\0\u031e\0\u0357\0\u0390\0\u03c9\0\u0402\0\u043b\0\u0474\0\u04ad"+
    "\0\344\0\u04e6\0\u051f\0\u0558\0\u0591\0\u05ca\0\u0603\0\u063c"+
    "\0\u0675\0\u06ae\0\u06e7\0\u0720\0\u0759\0\u0792\0\u07cb\0\u0804"+
    "\0\u083d\0\u0876\0\u08af\0\u08e8\0\u0921\0\u095a\0\u0993\0\u09cc"+
    "\0\u0a05\0\u0a3e\0\u0a77\0\u0ab0\0\u0ae9\0\u0b22\0\u0b5b\0\u0b94"+
    "\0\u0bcd\0\u0c06\0\u0c3f\0\u0c78\0\u0cb1\0\u0cea\0\u0d23\0\u0d5c"+
    "\0\u0d95\0\u0dce\0\u0e07\0\u0e40\0\u0e79\0\u0eb2\0\u0eeb\0\u0f24"+
    "\0\u0f5d\0\u0f96\0\u0fcf\0\u1008\0\u1041\0\u107a\0\u10b3\0\u10ec"+
    "\0\u1125\0\u115e\0\u1197\0\u11d0\0\u1209\0\u1242\0\u127b\0\u12b4"+
    "\0\u12ed\0\u1326\0\u135f\0\u1398\0\u13d1\0\u140a\0\u1443\0\u147c"+
    "\0\u14b5\0\u14ee\0\u1527\0\u1560\0\u1599\0\u15d2\0\u160b\0\u1644"+
    "\0\u167d\0\344\0\u16b6\0\u16ef\0\u1728\0\u1761\0\u179a\0\u17d3"+
    "\0\u180c\0\u1845\0\u187e\0\u18b7\0\u18f0\0\u1929\0\u1962\0\u199b"+
    "\0\u19d4\0\u1a0d\0\u1a46\0\u1a7f\0\u1ab8\0\u1af1\0\u1b2a\0\u1b63"+
    "\0\u1b9c\0\u1bd5\0\u1c0e\0\u1c47\0\u1c80\0\u1cb9\0\u1cf2\0\u1d2b"+
    "\0\u1d64\0\u1d64\0\u1d9d\0\u1dd6\0\u1e0f\0\u1e48\0\u1e81\0\u1eba"+
    "\0\u1ef3\0\u1f2c\0\u1f65\0\u1f9e\0\u1fd7\0\u2010\0\u2049\0\u2082"+
    "\0\u20bb\0\u20f4\0\u212d\0\u2166\0\u219f\0\u21d8\0\u2211\0\u224a"+
    "\0\u2283\0\u22bc\0\u22f5\0\u232e\0\u2367\0\u23a0\0\u23d9\0\u2412"+
    "\0\u244b\0\u2484\0\u24bd\0\u24f6\0\u252f\0\u2568\0\u25a1\0\u25da"+
    "\0\u2613\0\u264c\0\u2685\0\u26be\0\u26f7\0\u2730\0\u2769\0\u27a2"+
    "\0\u27db\0\u2814\0\u284d\0\u2886\0\u28bf\0\u28f8\0\u2931\0\u296a"+
    "\0\u29a3\0\u29dc\0\344\0\u2a15\0\u2a4e\0\u2a87\0\u2ac0\0\u2af9"+
    "\0\u2b32\0\u2b6b\0\u2b6b\0\u2ba4\0\u2bdd\0\u2c16\0\u2c4f\0\u2c88"+
    "\0\u2cc1\0\u2cc1\0\u2cfa\0\u2d33\0\u2d6c\0\u2da5\0\u2dde\0\u2dde"+
    "\0\u2e17\0\u2e50\0\u2e89\0\u2ec2\0\u2efb\0\u2f34\0\u2f6d\0\u2fa6"+
    "\0\u2fdf\0\u3018\0\u3051\0\u308a\0\u30c3\0\u30fc\0\u3135\0\u316e"+
    "\0\u31a7\0\u31e0\0\u3219\0\u3252\0\u328b\0\u32c4\0\u32fd\0\u3336"+
    "\0\u336f\0\u33a8\0\u33e1\0\u341a\0\u3453\0\u348c\0\u34c5\0\u34fe"+
    "\0\u3537\0\u3570\0\u35a9\0\u35e2\0\u361b\0\u3654\0\u368d\0\u36c6"+
    "\0\u36ff\0\u3738\0\u3771\0\u37aa\0\u37e3\0\u381c\0\u3855\0\u388e"+
    "\0\u38c7\0\u3900\0\u3939\0\u3972\0\u39ab\0\u39e4\0\u3a1d\0\u3a56"+
    "\0\344\0\u3a8f\0\u3ac8\0\u3b01\0\u3b3a\0\u3b73\0\u3bac\0\u3be5"+
    "\0\u3c1e\0\u3c57\0\u3c90\0\u3cc9\0\u3d02\0\u3d3b\0\u3d74\0\u3dad"+
    "\0\u3a56\0\u3de6\0\u3e1f\0\u3e58\0\u3e91\0\u3eca\0\u3f03\0\u3f3c"+
    "\0\u3f75\0\u3fae\0\u3fe7\0\u4020\0\u4059\0\u4092\0\u40cb\0\u4104"+
    "\0\u413d\0\u4176\0\u41af\0\u41e8\0\u4221\0\u425a\0\u4293\0\u42cc"+
    "\0\u4305\0\u433e\0\u4377\0\u43b0\0\u43e9\0\u4422\0\u445b\0\u4494"+
    "\0\u44cd\0\u4506\0\u453f\0\u4578\0\u45b1\0\u45ea\0\u4623\0\u465c"+
    "\0\u4695\0\u46ce\0\u4707\0\u4740\0\u4779\0\u47b2\0\u47eb\0\u4824"+
    "\0\u485d\0\u4896\0\u48cf\0\u4908\0\u4941\0\u497a\0\u49b3\0\u49ec"+
    "\0\u4a25\0\u4a5e\0\u4a97\0\u4ad0\0\u4b09\0\u4b42\0\u4b7b\0\u4bb4"+
    "\0\u4bed\0\u4c26\0\u4c5f\0\u4c98\0\u4cd1\0\u4d0a\0\u4d43\0\u4d7c"+
    "\0\u4db5\0\u4dee\0\u4e27\0\u4e60\0\u4e99\0\u4ed2\0\u4f0b\0\u4f44"+
    "\0\u4f7d\0\u4fb6\0\u4fef\0\u5028\0\u5061\0\u509a\0\u50d3\0\u510c"+
    "\0\u5145\0\u517e\0\u51b7\0\u51f0\0\u5229\0\u5262\0\u529b\0\u52d4"+
    "\0\u530d\0\u5346\0\u537f\0\u53b8\0\u53f1\0\u542a\0\u5463\0\u549c"+
    "\0\u54d5\0\u550e\0\u5547\0\u5580\0\u55b9\0\u55f2\0\u562b\0\u5664"+
    "\0\u569d\0\u56d6\0\u570f\0\u5748\0\u5781\0\u57ba\0\u57f3\0\u582c"+
    "\0\u5865\0\u589e\0\u58d7\0\u5910\0\u5949\0\u5982\0\u59bb\0\u59f4"+
    "\0\u5a2d\0\u5a66\0\u5a9f\0\u5ad8\0\u5b11\0\u5b4a\0\u5b83\0\u5bbc"+
    "\0\u5bf5\0\u5c2e\0\u5c67\0\u5ca0\0\u5cd9\0\u5d12\0\u5d4b\0\u5d84"+
    "\0\u5dbd\0\u5df6\0\u5e2f\0\u5e68\0\u5ea1\0\u5eda\0\u5f13\0\u5f4c"+
    "\0\u5f85\0\u5fbe\0\u5ff7\0\u6030\0\u6069\0\u60a2\0\u60db\0\u6114"+
    "\0\u614d\0\u6186\0\u61bf\0\u61f8\0\u6231\0\u626a\0\u62a3\0\u62dc"+
    "\0\u6315\0\u634e\0\u6387\0\u63c0\0\u63f9\0\u6432\0\u646b\0\u64a4"+
    "\0\u64dd\0\u6516\0\u654f\0\u6588\0\u65c1\0\u65fa\0\u6633\0\u666c"+
    "\0\u66a5\0\u66de\0\u6717\0\u6750\0\u6789\0\u67c2\0\u67fb\0\u6834"+
    "\0\u686d\0\u68a6\0\u68df\0\u6918\0\u6951\0\u698a\0\u69c3\0\u69fc"+
    "\0\u6a35\0\u6a6e\0\u6aa7\0\u6ae0\0\u6b19\0\u6b52\0\u6b8b\0\u6bc4"+
    "\0\u6bfd\0\u6c36\0\u6c6f\0\u6ca8\0\u6ce1\0\u6d1a\0\u6d53\0\u6d8c"+
    "\0\u6dc5\0\u6dfe\0\u6e37\0\u6e70\0\u6ea9\0\u6ee2\0\u6f1b\0\u6f54"+
    "\0\u6f8d\0\u6fc6\0\u6fff\0\u7038\0\u7071\0\u70aa\0\u70e3\0\u711c"+
    "\0\u7155\0\u718e\0\u71c7\0\u7200\0\u7239\0\u7272\0\u72ab\0\u72e4"+
    "\0\u731d\0\u7356\0\u738f\0\u73c8\0\u7401\0\u743a\0\u7473\0\u74ac"+
    "\0\u74e5\0\u751e\0\u7557\0\u7590\0\u75c9\0\u7602\0\u763b\0\u7674"+
    "\0\u76ad\0\u76e6\0\u771f\0\u7758\0\u7791\0\u77ca\0\u7803\0\u783c"+
    "\0\u7875\0\u78ae\0\u78e7\0\u7920\0\u7959\0\u7992\0\u79cb\0\u7a04"+
    "\0\u7a3d\0\u7a76\0\u7aaf\0\u7ae8\0\u7b21\0\u7b5a\0\u7b93\0\u7bcc"+
    "\0\u7c05\0\u7c3e\0\u7c77\0\u7cb0\0\u7ce9\0\u7d22\0\u7d5b\0\u7d94"+
    "\0\u7dcd\0\u7e06\0\u7e3f\0\u7e78\0\u7eb1\0\u7eea\0\u7f23\0\u7f5c"+
    "\0\u7f95\0\u7fce\0\u8007\0\u8040\0\u8079\0\u80b2\0\u80eb\0\u8124"+
    "\0\u815d\0\u8196\0\u81cf\0\u8208\0\u8241\0\u827a\0\u82b3\0\u82ec"+
    "\0\u8325\0\u835e\0\u8397\0\u83d0\0\u8409\0\u8442\0\u847b\0\u84b4"+
    "\0\u84ed\0\u8526\0\u855f\0\u8598\0\u85d1\0\u860a\0\u8643\0\u867c"+
    "\0\u86b5\0\u86ee\0\u8727\0\u8760\0\u8799\0\u87d2\0\u880b\0\u8844"+
    "\0\u887d\0\u88b6\0\u88ef\0\u8928\0\u8961\0\u899a\0\u89d3\0\u8a0c"+
    "\0\u8a45\0\u8a7e\0\u8ab7\0\u8af0\0\u8b29\0\u8b62\0\u8b9b\0\u8bd4"+
    "\0\u8c0d\0\u8c46\0\u8c7f\0\u8cb8\0\u8cf1\0\u8d2a\0\u8d63\0\u8d9c"+
    "\0\u8dd5\0\u8e0e\0\u8e47\0\u8e80\0\u8eb9\0\u8ef2\0\u8f2b\0\u8f64"+
    "\0\u8f9d\0\u8fd6\0\u900f\0\u9048\0\u9081\0\u90ba\0\u90f3\0\u912c"+
    "\0\u9165\0\u919e\0\u91d7\0\u9210\0\u9249\0\u9282\0\u92bb\0\u92f4"+
    "\0\u932d\0\u9366\0\u939f\0\u93d8\0\u9411\0\u944a\0\u9483\0\u94bc"+
    "\0\u94f5\0\u952e\0\u9567\0\u95a0\0\u95d9\0\u9612\0\u964b\0\u9684"+
    "\0\u96bd\0\u96f6\0\u972f\0\u9768\0\u97a1\0\u97da\0\u9813\0\u984c"+
    "\0\u9885\0\u98be\0\u98f7\0\u9930\0\u9969\0\u99a2\0\u99db\0\u9a14"+
    "\0\u9a4d\0\u9a86\0\u9abf\0\u9af8\0\u9b31\0\u9b6a\0\u9ba3\0\u9bdc"+
    "\0\u9c15\0\u9c4e\0\u9c87\0\u9cc0\0\u9cf9\0\u9d32\0\u9d6b\0\u9da4"+
    "\0\u9ddd\0\u9e16\0\u9e4f\0\u9e88\0\u9ec1\0\u9efa\0\u9f33\0\u9f6c"+
    "\0\u9fa5\0\u9fde\0\ua017\0\ua050\0\ua089\0\ua0c2\0\ua0fb\0\ua134"+
    "\0\ua16d\0\344\0\ua1a6\0\ua1df\0\ua218\0\ua251\0\ua28a\0\ua2c3"+
    "\0\ua2fc\0\344\0\ua335\0\ua36e\0\344\0\ua3a7\0\ua3e0\0\ua419"+
    "\0\ua452\0\ua48b\0\ua4c4\0\ua4fd\0\ua536\0\ua56f\0\ua5a8\0\ua1df"+
    "\0\ua5e1\0\ua61a\0\ua653\0\ua68c\0\ua6c5\0\ua6fe\0\ua737\0\ua770"+
    "\0\ua7a9\0\ua7e2\0\ua81b\0\ua854\0\ua88d\0\ua8c6\0\ua8ff\0\ua938"+
    "\0\ua971\0\ua9aa\0\ua9e3\0\uaa1c\0\uaa55\0\uaa8e\0\uaac7\0\uab00"+
    "\0\uab39\0\uab72\0\uabab\0\uabe4\0\uac1d\0\uac56\0\uac8f\0\uacc8"+
    "\0\uad01\0\uad3a\0\uad73\0\uadac\0\uade5\0\uae1e\0\uae57\0\uae90"+
    "\0\uaec9\0\uaf02\0\uaf3b\0\uaf74\0\uafad\0\uafe6\0\ub01f\0\ub058"+
    "\0\ub091\0\ub0ca\0\ub103\0\ub13c\0\ub175\0\ub1ae\0\ub1e7\0\ub220"+
    "\0\ub259\0\ub292\0\ub2cb\0\ub304\0\ub33d\0\ub376\0\ub3af\0\ub3e8"+
    "\0\ub421\0\ub45a\0\ub493\0\ub4cc\0\ub505\0\ub53e\0\ub577\0\ub5b0"+
    "\0\ub5e9\0\ub622\0\ub65b\0\ub694\0\ub6cd\0\ub706\0\ub73f\0\ub778"+
    "\0\ub7b1\0\ub7ea\0\ub823\0\ub85c\0\ub895\0\ub8ce\0\ub907\0\ub940"+
    "\0\ub979\0\ub9b2\0\ub9eb\0\uba24\0\uba5d\0\uba96\0\ubacf\0\ubb08"+
    "\0\ubb41\0\ubb7a\0\ubbb3\0\ubbec\0\ubc25\0\344\0\ubc5e\0\ubc97"+
    "\0\ubcd0\0\ubd09\0\ubd42\0\ubd7b\0\ubdb4\0\ubded\0\ube26\0\ube5f"+
    "\0\ube98\0\ubbb3\0\ubed1\0\ubf0a\0\ubf43\0\ubf7c\0\ubfb5\0\ubfee"+
    "\0\uc027\0\uc060\0\uc099\0\uc0d2\0\uc10b\0\uc144\0\uc17d\0\uc1b6"+
    "\0\uc1ef\0\uc228\0\uc261\0\uc29a\0\uc2d3\0\uc30c\0\uc345\0\uc37e"+
    "\0\uc3b7\0\uc3f0\0\uc429\0\uc462\0\uc49b\0\uc4d4\0\uc50d\0\uc546"+
    "\0\uc57f\0\uc5b8\0\uc5f1\0\uc62a\0\uc663\0\uc69c\0\uc6d5\0\uc70e"+
    "\0\uc747\0\uc780\0\uc7b9\0\uc7f2\0\uc82b\0\uc864\0\uc89d\0\uc8d6"+
    "\0\uc90f\0\uc948\0\uc981\0\uc9ba\0\uc9f3\0\uca2c\0\uca65\0\uca9e"+
    "\0\ucad7\0\ucb10\0\ucb49\0\ucb82\0\ucbbb\0\ucbf4\0\ucc2d\0\ucc66"+
    "\0\ucc9f\0\uccd8\0\ucd11\0\ucd4a\0\ucd83\0\ucdbc\0\ucdf5\0\uce2e"+
    "\0\uce67\0\ucea0\0\uced9\0\ucf12\0\ucf4b\0\ucf84\0\ucfbd\0\ucff6"+
    "\0\ud02f\0\ud068\0\ud0a1\0\ud0da\0\ud113\0\ud14c\0\ud185\0\ud1be"+
    "\0\ud1f7\0\ud230\0\ud269\0\ud2a2\0\ud2db\0\ud314\0\ud34d\0\ud386"+
    "\0\ud3bf\0\ud3f8\0\ud431";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[971];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\41\5\1\6\27\5\41\7\1\10\27\7\41\11\1\12"+
    "\70\11\1\13\27\11\116\0\1\14\27\0\1\14\22\0"+
    "\1\15\106\0\1\16\27\0\1\16\40\0\1\17\27\0"+
    "\1\17\37\0\1\20\27\0\1\20\41\0\1\21\27\0"+
    "\1\21\37\0\1\22\27\0\1\22\40\0\1\23\27\0"+
    "\1\23\43\0\1\24\27\0\1\24\35\0\1\25\27\0"+
    "\1\25\43\0\1\26\27\0\1\26\40\0\1\27\27\0"+
    "\1\27\22\0\1\30\106\0\1\31\27\0\1\31\22\0"+
    "\1\32\70\0\1\33\72\0\4\34\1\35\5\34\1\36"+
    "\3\34\1\37\1\40\6\34\2\0\1\34\4\0\1\41"+
    "\4\0\1\42\3\0\1\43\1\44\21\0\16\45\1\46"+
    "\7\45\2\0\1\45\15\0\1\47\22\0\4\45\1\50"+
    "\5\45\1\51\3\45\1\52\1\53\6\45\2\0\1\45"+
    "\4\0\1\54\4\0\1\55\3\0\1\56\1\57\17\0"+
    "\1\60\1\0\26\34\2\0\1\34\36\0\1\60\1\0"+
    "\22\34\1\61\3\34\2\0\1\34\21\0\1\62\14\0"+
    "\1\60\1\0\4\34\1\63\21\34\2\0\1\34\4\0"+
    "\1\64\31\0\1\60\1\0\1\65\25\34\2\0\1\34"+
    "\1\66\35\0\1\60\1\0\4\34\1\67\21\34\2\0"+
    "\1\34\4\0\1\70\55\0\1\62\27\0\1\62\22\0"+
    "\1\64\30\0\1\64\33\0\1\66\30\0\1\66\43\0"+
    "\1\70\30\0\1\70\31\0\1\71\1\0\26\45\2\0"+
    "\1\45\36\0\1\71\1\0\1\72\25\45\2\0\1\45"+
    "\1\73\37\0\1\73\30\0\1\73\35\0\1\71\1\0"+
    "\22\45\1\74\3\45\2\0\1\45\21\0\1\75\14\0"+
    "\1\71\1\0\4\45\1\76\21\45\2\0\1\45\4\0"+
    "\1\77\31\0\1\71\1\0\1\100\25\45\2\0\1\45"+
    "\1\101\35\0\1\71\1\0\4\45\1\102\21\45\2\0"+
    "\1\45\4\0\1\103\55\0\1\75\27\0\1\75\22\0"+
    "\1\77\30\0\1\77\33\0\1\101\30\0\1\101\43\0"+
    "\1\103\30\0\1\103\20\0\2\60\2\0\5\60\1\104"+
    "\27\60\2\0\26\60\11\0\1\60\1\0\26\34\2\0"+
    "\1\105\70\0\1\106\36\0\1\60\1\0\6\34\1\107"+
    "\17\34\2\0\1\34\6\0\1\110\37\0\1\110\30\0"+
    "\1\110\27\0\1\60\1\0\17\34\1\111\6\34\2\0"+
    "\1\34\16\0\1\112\40\0\1\112\27\0\1\112\17\0"+
    "\1\60\1\0\5\34\1\113\20\34\2\0\1\34\5\0"+
    "\1\114\37\0\1\114\30\0\1\114\17\0\2\71\2\0"+
    "\5\71\1\115\27\71\2\0\26\71\11\0\1\71\1\0"+
    "\17\45\1\116\6\45\2\0\1\45\16\0\1\117\40\0"+
    "\1\117\27\0\1\117\17\0\1\71\1\0\26\45\2\0"+
    "\1\120\70\0\1\121\36\0\1\71\1\0\6\45\1\122"+
    "\17\45\2\0\1\45\6\0\1\123\37\0\1\123\30\0"+
    "\1\123\27\0\1\71\1\0\17\45\1\124\6\45\2\0"+
    "\1\45\16\0\1\125\40\0\1\125\27\0\1\125\17\0"+
    "\1\71\1\0\5\45\1\126\20\45\2\0\1\45\5\0"+
    "\1\127\37\0\1\127\30\0\1\127\27\0\1\130\71\0"+
    "\1\60\1\0\12\34\1\131\13\34\2\0\1\34\11\0"+
    "\1\132\40\0\1\132\27\0\1\132\24\0\1\60\1\0"+
    "\26\34\2\0\1\133\70\0\1\134\36\0\1\60\1\0"+
    "\21\34\1\135\4\34\2\0\1\34\20\0\1\136\40\0"+
    "\1\136\27\0\1\136\15\0\1\137\1\0\26\34\2\0"+
    "\1\34\36\0\1\140\67\0\1\141\71\0\1\71\1\0"+
    "\21\45\1\142\4\45\2\0\1\45\20\0\1\143\40\0"+
    "\1\143\27\0\1\143\15\0\1\71\1\0\12\45\1\51"+
    "\13\45\2\0\1\45\11\0\1\55\40\0\1\55\27\0"+
    "\1\55\24\0\1\71\1\0\26\45\2\0\1\144\70\0"+
    "\1\145\36\0\1\71\1\0\21\45\1\146\4\45\2\0"+
    "\1\45\20\0\1\147\40\0\1\147\27\0\1\147\15\0"+
    "\1\150\1\0\26\45\2\0\1\45\36\0\1\151\67\0"+
    "\1\130\31\0\1\152\37\0\1\60\1\0\4\34\1\153"+
    "\21\34\2\0\1\34\4\0\1\154\37\0\1\154\30\0"+
    "\1\154\31\0\1\60\1\0\17\34\1\40\6\34\2\0"+
    "\1\34\16\0\1\44\40\0\1\44\27\0\1\44\17\0"+
    "\1\60\1\0\10\34\1\155\15\34\2\0\1\34\7\0"+
    "\1\156\40\0\1\156\27\0\1\156\15\0\2\137\2\0"+
    "\5\137\1\157\27\137\2\0\26\137\2\140\2\0\5\140"+
    "\1\160\27\140\2\0\26\140\10\0\1\141\31\0\1\161"+
    "\37\0\1\71\1\0\10\45\1\162\15\45\2\0\1\45"+
    "\7\0\1\163\40\0\1\163\27\0\1\163\26\0\1\71"+
    "\1\0\17\45\1\53\6\45\2\0\1\45\16\0\1\57"+
    "\40\0\1\57\27\0\1\57\17\0\1\71\1\0\10\45"+
    "\1\164\15\45\2\0\1\45\7\0\1\165\40\0\1\165"+
    "\27\0\1\165\15\0\2\150\2\0\5\150\1\166\27\150"+
    "\2\0\26\150\2\151\2\0\5\151\1\167\27\151\2\0"+
    "\26\151\11\0\1\60\1\0\6\34\1\170\17\34\2\0"+
    "\1\34\6\0\1\171\37\0\1\171\30\0\1\171\27\0"+
    "\1\60\1\0\21\34\1\172\4\34\2\0\1\34\20\0"+
    "\1\173\40\0\1\173\27\0\1\173\14\0\1\174\70\0"+
    "\1\175\60\0\41\176\1\0\27\176\11\0\1\71\1\0"+
    "\21\45\1\177\4\45\2\0\1\45\20\0\1\200\40\0"+
    "\1\200\27\0\1\200\15\0\1\71\1\0\21\45\1\201"+
    "\4\45\2\0\1\45\20\0\1\202\40\0\1\202\27\0"+
    "\1\202\14\0\1\203\70\0\1\204\71\0\1\60\1\0"+
    "\26\34\2\0\1\205\70\0\1\206\36\0\1\60\1\0"+
    "\10\34\1\207\15\34\2\0\1\34\7\0\1\210\40\0"+
    "\1\210\27\0\1\210\25\0\1\174\31\0\1\211\36\0"+
    "\1\175\31\0\1\212\26\0\41\176\1\213\27\176\11\0"+
    "\1\71\1\0\10\45\1\214\15\45\2\0\1\45\7\0"+
    "\1\215\40\0\1\215\27\0\1\215\26\0\1\71\1\0"+
    "\10\45\1\216\15\45\2\0\1\45\7\0\1\217\40\0"+
    "\1\217\27\0\1\217\25\0\1\203\31\0\1\220\36\0"+
    "\1\204\31\0\1\221\37\0\1\60\1\0\17\34\1\222"+
    "\6\34\2\0\1\34\16\0\1\223\40\0\1\223\27\0"+
    "\1\223\17\0\1\60\1\0\15\34\1\224\10\34\2\0"+
    "\1\34\14\0\1\225\40\0\1\225\27\0\1\225\10\0"+
    "\41\226\1\0\27\226\7\0\1\227\72\0\1\71\1\0"+
    "\15\45\1\230\10\45\2\0\1\45\14\0\1\231\40\0"+
    "\1\231\27\0\1\231\21\0\1\71\1\0\15\45\1\232"+
    "\10\45\2\0\1\45\14\0\1\233\40\0\1\233\27\0"+
    "\1\233\10\0\41\234\1\0\27\234\41\235\1\0\27\235"+
    "\11\0\1\60\1\0\4\34\1\236\21\34\2\0\1\34"+
    "\4\0\1\237\37\0\1\237\30\0\1\237\31\0\1\60"+
    "\1\0\14\34\1\240\11\34\2\0\1\34\13\0\1\241"+
    "\40\0\1\241\27\0\1\241\11\0\41\226\1\242\27\226"+
    "\25\0\1\243\27\0\1\243\24\0\1\71\1\0\14\45"+
    "\1\244\11\45\2\0\1\45\13\0\1\245\40\0\1\245"+
    "\27\0\1\245\22\0\1\71\1\0\14\45\1\246\11\45"+
    "\2\0\1\45\13\0\1\247\40\0\1\247\27\0\1\247"+
    "\11\0\41\234\1\250\27\234\41\235\1\251\27\235\11\0"+
    "\1\60\1\0\5\34\1\252\20\34\2\0\1\34\5\0"+
    "\1\253\37\0\1\253\30\0\1\253\30\0\1\254\1\0"+
    "\26\34\2\0\1\34\36\0\1\255\66\0\1\256\105\0"+
    "\1\257\27\0\1\257\25\0\1\260\1\0\26\45\2\0"+
    "\1\45\36\0\1\260\70\0\1\261\1\0\26\45\2\0"+
    "\1\45\36\0\1\261\66\0\1\262\70\0\1\263\72\0"+
    "\1\264\1\0\26\34\2\0\1\34\36\0\1\265\57\0"+
    "\2\254\2\0\5\254\1\266\27\254\2\0\26\254\2\255"+
    "\2\0\5\255\1\267\27\255\2\0\26\255\25\0\1\270"+
    "\27\0\1\270\42\0\1\271\27\0\1\271\11\0\2\260"+
    "\2\0\5\260\1\272\27\260\2\0\26\260\2\261\2\0"+
    "\5\261\1\273\27\261\2\0\26\261\25\0\1\274\27\0"+
    "\1\274\40\0\1\275\27\0\1\275\13\0\2\264\2\0"+
    "\5\264\1\276\27\264\2\0\26\264\2\265\2\0\5\265"+
    "\1\277\27\265\2\0\26\265\10\0\1\300\70\0\1\301"+
    "\104\0\1\302\27\0\1\302\56\0\1\303\36\0\1\304"+
    "\70\0\1\305\104\0\1\306\27\0\1\306\40\0\1\307"+
    "\27\0\1\307\24\0\1\310\70\0\1\311\70\0\1\300"+
    "\31\0\1\312\36\0\1\301\31\0\1\313\55\0\1\314"+
    "\27\0\1\314\21\0\1\304\31\0\1\315\36\0\1\305"+
    "\31\0\1\316\55\0\1\317\27\0\1\317\40\0\1\320"+
    "\27\0\1\320\21\0\1\310\31\0\1\321\36\0\1\311"+
    "\31\0\1\322\26\0\41\323\1\0\27\323\42\0\1\324"+
    "\26\0\41\325\1\0\27\325\41\326\1\0\27\326\42\0"+
    "\1\327\70\0\1\330\26\0\41\331\1\0\27\331\41\323"+
    "\1\332\27\323\1\0\2\324\1\0\1\333\2\324\22\0"+
    "\1\334\7\0\1\335\1\0\1\324\15\0\1\334\7\0"+
    "\41\325\1\336\27\325\41\326\1\337\27\326\1\0\2\330"+
    "\1\0\1\340\2\330\22\0\1\341\7\0\1\342\1\0"+
    "\1\330\15\0\1\341\7\0\41\331\1\343\27\331\7\0"+
    "\1\344\110\0\1\345\27\0\1\345\24\0\1\346\30\0"+
    "\1\346\51\0\1\347\27\0\1\347\22\0\1\350\70\0"+
    "\1\351\110\0\1\352\27\0\1\352\24\0\1\353\30\0"+
    "\1\353\51\0\1\354\27\0\1\354\22\0\1\355\106\0"+
    "\1\356\27\0\1\356\27\0\1\357\30\0\1\357\55\0"+
    "\1\360\27\0\1\360\32\0\1\361\27\0\1\361\41\0"+
    "\1\362\27\0\1\362\40\0\1\363\27\0\1\363\27\0"+
    "\1\364\30\0\1\364\55\0\1\365\27\0\1\365\32\0"+
    "\1\366\27\0\1\366\41\0\1\367\27\0\1\367\37\0"+
    "\1\370\27\0\1\370\47\0\1\371\27\0\1\371\41\0"+
    "\1\372\27\0\1\372\33\0\1\373\27\0\1\373\35\0"+
    "\1\374\27\0\1\374\40\0\1\375\27\0\1\375\47\0"+
    "\1\376\27\0\1\376\41\0\1\377\27\0\1\377\33\0"+
    "\1\u0100\27\0\1\u0100\35\0\1\u0101\27\0\1\u0101\43\0"+
    "\1\u0102\27\0\1\u0102\42\0\1\u0103\27\0\1\u0103\32\0"+
    "\1\u0104\27\0\1\u0104\26\0\1\u0105\106\0\1\u0106\27\0"+
    "\1\u0106\40\0\1\u0107\27\0\1\u0107\42\0\1\u0108\27\0"+
    "\1\u0108\32\0\1\u0109\27\0\1\u0109\26\0\1\u010a\106\0"+
    "\1\u010b\27\0\1\u010b\53\0\1\u010c\40\0\1\324\73\0"+
    "\1\u010d\30\0\1\u010d\53\0\1\u010e\1\0\1\u010f\25\0"+
    "\1\u010e\1\0\1\u010f\47\0\1\u0110\70\0\1\u0111\40\0"+
    "\1\330\73\0\1\u0112\30\0\1\u0112\53\0\1\u0113\1\0"+
    "\1\u0114\25\0\1\u0113\1\0\1\u0114\47\0\1\u0115\27\0"+
    "\2\u010c\1\0\1\u0116\1\u0117\1\u010c\2\0\2\u0118\1\u0119"+
    "\2\0\1\u011a\10\0\1\u011b\2\0\1\u011c\6\0\1\u011d"+
    "\1\0\1\u010c\1\u0119\2\0\1\u011a\7\0\1\u011b\2\0"+
    "\1\u011c\36\0\1\u011e\27\0\1\u011e\23\0\1\u011f\30\0"+
    "\1\u011f\60\0\1\u0120\27\0\1\u0120\5\0\2\u0121\1\0"+
    "\1\u0122\2\u0121\4\0\1\u0123\2\0\1\u0124\10\0\1\u0125"+
    "\11\0\1\u0126\1\0\1\u0121\1\u0123\2\0\1\u0124\7\0"+
    "\1\u0125\41\0\1\u0127\27\0\1\u0127\23\0\1\u0128\30\0"+
    "\1\u0128\60\0\1\u0129\27\0\1\u0129\5\0\2\u0115\1\0"+
    "\1\u012a\2\u0115\22\0\1\u012b\7\0\1\u012c\1\0\1\u0115"+
    "\15\0\1\u012b\36\0\1\u012d\27\0\1\u012d\12\0\2\u0117"+
    "\1\0\1\u012e\2\u0117\4\0\1\u0119\2\0\1\u011a\10\0"+
    "\1\u011b\11\0\1\u012f\1\0\1\u0117\1\u0119\2\0\1\u011a"+
    "\7\0\1\u011b\12\0\2\u0118\1\0\1\u0130\1\0\1\u0118"+
    "\2\0\2\u0118\17\0\1\u011c\6\0\1\u0131\1\0\1\u0118"+
    "\16\0\1\u011c\33\0\1\u0132\1\0\1\u0133\25\0\1\u0132"+
    "\1\0\1\u0133\34\0\1\u0134\27\0\1\u0134\45\0\1\u0135"+
    "\27\0\1\u0135\27\0\1\u0136\30\0\1\u0136\45\0\1\u0137"+
    "\27\0\1\u0137\40\0\1\u0138\27\0\1\u0138\45\0\1\u0139"+
    "\27\0\1\u0139\37\0\1\u013a\27\0\1\u013a\36\0\1\u013b"+
    "\27\0\1\u013b\36\0\1\u013c\1\0\1\u013d\25\0\1\u013c"+
    "\1\0\1\u013d\34\0\1\u013e\27\0\1\u013e\45\0\1\u013f"+
    "\27\0\1\u013f\35\0\1\u0140\27\0\1\u0140\40\0\1\u0141"+
    "\27\0\1\u0141\45\0\1\u0142\27\0\1\u0142\37\0\1\u0143"+
    "\27\0\1\u0143\36\0\1\u0144\27\0\1\u0144\24\0\1\u0145"+
    "\30\0\1\u0145\51\0\1\u0146\27\0\1\u0146\27\0\1\u0147"+
    "\30\0\1\u0147\52\0\1\u0148\27\0\1\u0148\36\0\1\u0149"+
    "\27\0\1\u0149\42\0\1\u014a\27\0\1\u014a\36\0\1\u014b"+
    "\27\0\1\u014b\40\0\1\u014c\27\0\1\u014c\42\0\1\u014d"+
    "\27\0\1\u014d\44\0\1\u014e\27\0\1\u014e\37\0\1\u014f"+
    "\27\0\1\u014f\33\0\1\u0150\27\0\1\u0150\37\0\1\u0151"+
    "\27\0\1\u0151\27\0\1\u0152\30\0\1\u0152\60\0\1\u0153"+
    "\27\0\1\u0153\43\0\1\114\27\0\1\114\15\0\1\u0154"+
    "\30\0\1\u0154\50\0\1\u0155\27\0\1\u0155\42\0\1\u0156"+
    "\27\0\1\u0156\44\0\1\u0157\27\0\1\u0157\37\0\1\u0158"+
    "\27\0\1\u0158\32\0\1\u0159\27\0\1\u0159\27\0\1\u015a"+
    "\30\0\1\u015a\60\0\1\u015b\27\0\1\u015b\43\0\1\127"+
    "\27\0\1\127\15\0\1\u015c\30\0\1\u015c\55\0\1\u015d"+
    "\27\0\1\u015d\32\0\1\u015e\27\0\1\u015e\47\0\1\u015f"+
    "\27\0\1\u015f\21\0\1\u0160\30\0\1\u0160\47\0\1\u0161"+
    "\27\0\1\u0161\30\0\1\u0162\30\0\1\u0162\47\0\1\u0163"+
    "\27\0\1\u0163\33\0\1\u0164\30\0\1\u0164\37\0\1\u0165"+
    "\30\0\1\u0165\51\0\1\u0166\27\0\1\u0166\35\0\1\u0167"+
    "\27\0\1\u0167\25\0\1\u0168\30\0\1\u0168\53\0\1\u0169"+
    "\27\0\1\u0169\43\0\1\u016a\27\0\1\u016a\31\0\1\u016b"+
    "\27\0\1\u016b\50\0\1\u016c\27\0\1\u016c\24\0\1\u016d"+
    "\30\0\1\u016d\37\0\1\u016e\30\0\1\u016e\51\0\1\u016f"+
    "\27\0\1\u016f\35\0\1\u0170\27\0\1\u0170\41\0\1\u0171"+
    "\27\0\1\u0171\43\0\1\u0172\27\0\1\u0172\31\0\1\u0173"+
    "\27\0\1\u0173\50\0\1\u0174\27\0\1\u0174\41\0\1\u0175"+
    "\27\0\1\u0175\33\0\1\u0176\27\0\1\u0176\42\0\1\u0177"+
    "\27\0\1\u0177\42\0\1\u0178\27\0\1\u0178\34\0\1\u0179"+
    "\27\0\1\u0179\44\0\1\u017a\27\0\1\u017a\34\0\1\u017b"+
    "\27\0\1\u017b\32\0\1\u017c\30\0\1\u017c\51\0\1\u017d"+
    "\27\0\1\u017d\35\0\1\u017e\27\0\1\u017e\27\0\1\u017f"+
    "\30\0\1\u017f\60\0\1\u0180\27\0\1\u0180\11\0\1\u0181"+
    "\76\0\1\u0182\30\0\1\u0182\54\0\1\u0183\27\0\1\u0183"+
    "\35\0\1\u0184\27\0\1\u0184\30\0\1\u0185\30\0\1\u0185"+
    "\51\0\1\u0186\27\0\1\u0186\35\0\1\u0187\27\0\1\u0187"+
    "\27\0\1\u0188\30\0\1\u0188\31\0\1\u0189\76\0\1\u018a"+
    "\30\0\1\u018a\54\0\1\u018b\27\0\1\u018b\35\0\1\u018c"+
    "\27\0\1\u018c\32\0\1\u018d\27\0\1\u018d\26\0\1\u018e"+
    "\71\0\1\u010c\107\0\1\u018f\27\0\1\u018f\20\0\1\u0190"+
    "\110\0\1\u0191\27\0\1\u0191\20\0\1\u0192\72\0\1\u0193"+
    "\30\0\1\u0193\57\0\1\u0194\27\0\1\u0194\40\0\1\u0195"+
    "\27\0\1\u0195\6\0\2\u017f\1\0\1\u0196\6\0\1\u0197"+
    "\30\0\1\u0197\47\0\1\u0198\27\0\1\u0198\34\0\1\u0199"+
    "\5\0\1\u019a\1\u019b\2\0\1\43\1\u019c\1\u019d\14\0"+
    "\1\u0199\4\0\1\u019a\1\u019b\2\0\1\43\1\u019c\1\u019d"+
    "\6\0\2\u0182\1\0\1\u019e\2\u0182\32\0\1\u019f\1\0"+
    "\1\u0182\50\0\1\u01a0\27\0\1\u01a0\27\0\1\u0121\71\0"+
    "\1\u01a1\30\0\1\u01a1\57\0\1\u01a2\27\0\1\u01a2\40\0"+
    "\1\u01a3\27\0\1\u01a3\6\0\2\u0188\1\0\1\u01a4\6\0"+
    "\1\u01a5\30\0\1\u01a5\43\0\1\u01a6\5\0\1\u01a7\1\u01a8"+
    "\3\0\1\u01a9\1\u01aa\14\0\1\u01a6\4\0\1\u01a7\1\u01a8"+
    "\3\0\1\u01a9\1\u01aa\6\0\2\u018a\1\0\1\u01ab\2\u018a"+
    "\32\0\1\u01ac\1\0\1\u018a\50\0\1\u01ad\27\0\1\u01ad"+
    "\27\0\1\u0115\73\0\1\u01ae\30\0\1\u01ae\53\0\1\u01af"+
    "\1\0\1\u01b0\25\0\1\u01af\1\0\1\u01b0\17\0\1\u0117"+
    "\75\0\1\u0199\5\0\1\u019a\1\u019b\3\0\1\u019c\1\u01b1"+
    "\14\0\1\u0199\4\0\1\u019a\1\u019b\3\0\1\u019c\1\u01b1"+
    "\17\0\1\u0118\107\0\1\43\1\0\1\u01b2\25\0\1\43"+
    "\1\0\1\u01b2\41\0\1\u0194\27\0\1\u0194\17\0\1\u01b3"+
    "\3\0\1\u01b3\3\0\1\u01b3\4\0\1\u01b3\13\0\1\u01b3"+
    "\3\0\1\u01b3\2\0\1\u01b3\4\0\1\u01b3\33\0\1\u01b4"+
    "\27\0\1\u01b4\44\0\1\u01b5\27\0\1\u01b5\42\0\1\u01b6"+
    "\27\0\1\u01b6\37\0\1\u01b7\27\0\1\u01b7\45\0\1\u01b8"+
    "\27\0\1\u01b8\22\0\1\u01b9\30\0\1\u01b9\43\0\1\u01ba"+
    "\27\0\1\u01ba\34\0\1\u01bb\30\0\1\u01bb\54\0\1\u01bc"+
    "\27\0\1\u01bc\33\0\1\u01bd\27\0\1\u01bd\36\0\1\u01be"+
    "\27\0\1\u01be\43\0\1\u01bf\27\0\1\u01bf\44\0\1\u01a2"+
    "\27\0\1\u01a2\17\0\1\u01c0\3\0\1\u01c0\3\0\1\u01c0"+
    "\4\0\1\u01c0\13\0\1\u01c0\3\0\1\u01c0\2\0\1\u01c0"+
    "\4\0\1\u01c0\33\0\1\u01c1\27\0\1\u01c1\44\0\1\u01c2"+
    "\27\0\1\u01c2\42\0\1\u01c3\27\0\1\u01c3\44\0\1\u01c4"+
    "\27\0\1\u01c4\22\0\1\u01c5\30\0\1\u01c5\43\0\1\u01c6"+
    "\27\0\1\u01c6\34\0\1\u01c7\30\0\1\u01c7\54\0\1\u01c8"+
    "\27\0\1\u01c8\33\0\1\u01c9\27\0\1\u01c9\36\0\1\u01ca"+
    "\27\0\1\u01ca\43\0\1\u01cb\27\0\1\u01cb\40\0\1\u01cc"+
    "\27\0\1\u01cc\23\0\1\u01cd\30\0\1\u01cd\60\0\1\u01ce"+
    "\27\0\1\u01ce\40\0\1\u01cf\27\0\1\u01cf\40\0\1\u01d0"+
    "\27\0\1\u01d0\5\0\2\u01b3\1\0\1\u01d1\2\u01b3\7\0"+
    "\1\u011a\10\0\1\u011b\11\0\1\u01d2\1\0\1\u01b3\3\0"+
    "\1\u011a\7\0\1\u011b\51\0\1\u01d3\27\0\1\u01d3\14\0"+
    "\1\u01d4\30\0\1\u01d4\54\0\1\u01d5\27\0\1\u01d5\36\0"+
    "\1\u01d6\27\0\1\u01d6\54\0\1\u01d7\46\0\1\u01d8\30\0"+
    "\1\u01d8\51\0\1\u01d9\27\0\1\u01d9\25\0\1\u01da\30\0"+
    "\1\u01da\50\0\1\u01db\27\0\1\u01db\23\0\1\u01dc\30\0"+
    "\1\u01dc\47\0\1\u01dd\27\0\1\u01dd\43\0\1\u01de\27\0"+
    "\1\u01de\12\0\2\u01c0\1\0\1\u01df\2\u01c0\7\0\1\u0124"+
    "\10\0\1\u0125\11\0\1\u01e0\1\0\1\u01c0\3\0\1\u0124"+
    "\7\0\1\u0125\51\0\1\u01e1\27\0\1\u01e1\14\0\1\u01e2"+
    "\30\0\1\u01e2\54\0\1\u01e3\27\0\1\u01e3\52\0\1\u01e4"+
    "\46\0\1\u01e5\30\0\1\u01e5\51\0\1\u01e6\27\0\1\u01e6"+
    "\25\0\1\u01e7\30\0\1\u01e7\50\0\1\u01e8\27\0\1\u01e8"+
    "\23\0\1\u01e9\30\0\1\u01e9\47\0\1\u01ea\27\0\1\u01ea"+
    "\43\0\1\u01eb\27\0\1\u01eb\36\0\1\u01ec\27\0\1\u01ec"+
    "\45\0\1\u01ed\27\0\1\u01ed\37\0\1\u01ee\27\0\1\u01ee"+
    "\40\0\1\u01ef\27\0\1\u01ef\40\0\1\u01f0\27\0\1\u01f0"+
    "\36\0\1\u01f1\27\0\1\u01f1\36\0\1\u01f2\27\0\1\u01f2"+
    "\36\0\1\u01f3\27\0\1\u01f3\50\0\1\u01f4\27\0\1\u01f4"+
    "\37\0\1\u01f5\27\0\1\u01f5\25\0\1\u0118\30\0\1\u0118"+
    "\45\0\1\u01f6\27\0\1\u01f6\56\0\1\u01f7\42\0\1\u01f8"+
    "\30\0\1\u01f8\33\0\1\u01f9\116\0\1\241\27\0\1\241"+
    "\34\0\1\u01fa\27\0\1\u01fa\34\0\1\u01fb\27\0\1\u01fb"+
    "\22\0\1\u01fc\106\0\1\u01fd\27\0\1\u01fd\36\0\1\u01fe"+
    "\27\0\1\u01fe\36\0\1\u01ff\27\0\1\u01ff\50\0\1\u0200"+
    "\27\0\1\u0200\37\0\1\u0201\27\0\1\u0201\33\0\1\u01a7"+
    "\27\0\1\u01a7\56\0\1\u0202\42\0\1\u0203\30\0\1\u0203"+
    "\33\0\1\u0204\116\0\1\u0205\27\0\1\u0205\34\0\1\u0206"+
    "\27\0\1\u0206\34\0\1\u0207\27\0\1\u0207\22\0\1\u0208"+
    "\72\0\1\u0209\30\0\1\u0209\60\0\1\u020a\27\0\1\u020a"+
    "\43\0\1\253\27\0\1\253\40\0\1\u020b\27\0\1\u020b"+
    "\40\0\1\u020c\27\0\1\u020c\15\0\1\u020d\30\0\1\u020d"+
    "\47\0\1\u020e\27\0\1\u020e\44\0\1\u020f\27\0\1\u020f"+
    "\41\0\1\u0210\27\0\1\u0210\37\0\1\u0211\27\0\1\u0211"+
    "\27\0\1\u0212\30\0\1\u0212\52\0\1\u019c\27\0\1\u019c"+
    "\17\0\1\u0213\57\0\2\u01f9\2\0\5\u01f9\1\u0214\27\u01f9"+
    "\2\0\26\u01f9\31\0\1\u0215\27\0\1\u0215\20\0\1\u0216"+
    "\57\0\2\u01fc\2\0\5\u01fc\1\u0217\27\u01fc\2\0\26\u01fc"+
    "\14\0\1\u0218\30\0\1\u0218\47\0\1\u0219\27\0\1\u0219"+
    "\44\0\1\u021a\27\0\1\u021a\41\0\1\u021b\27\0\1\u021b"+
    "\37\0\1\u021c\27\0\1\u021c\42\0\1\u01a9\27\0\1\u01a9"+
    "\17\0\1\u021d\57\0\2\u0204\2\0\5\u0204\1\u021e\27\u0204"+
    "\2\0\26\u0204\11\0\1\u021f\110\0\1\u0220\27\0\1\u0220"+
    "\20\0\1\u0221\57\0\2\u0208\2\0\5\u0208\1\u0222\27\u0208"+
    "\2\0\26\u0208\32\0\1\u0223\27\0\1\u0223\31\0\1\u0224"+
    "\27\0\1\u0224\26\0\1\u0225\70\0\1\u0226\112\0\1\u0227"+
    "\27\0\1\u0227\34\0\1\u0228\27\0\1\u0228\40\0\1\u0229"+
    "\27\0\1\u0229\23\0\1\u017f\114\0\1\u022a\27\0\1\u022a"+
    "\23\0\1\u022b\30\0\1\u022b\16\0\2\u022c\2\0\5\u022c"+
    "\1\u022d\21\u022c\1\u022e\5\u022c\2\0\20\u022c\1\u022e\5\u022c"+
    "\10\0\1\u022f\72\0\1\u0182\107\0\1\u010e\1\0\1\u0230"+
    "\25\0\1\u010e\1\0\1\u0230\15\0\1\u0231\113\0\1\u0232"+
    "\27\0\1\u0232\34\0\1\u0233\27\0\1\u0233\40\0\1\u0234"+
    "\27\0\1\u0234\23\0\1\u0188\114\0\1\u0235\27\0\1\u0235"+
    "\2\0\2\u0236\2\0\5\u0236\1\u0237\21\u0236\1\u0238\5\u0236"+
    "\2\0\20\u0236\1\u0238\5\u0236\10\0\1\u0239\60\0\2\u021f"+
    "\2\0\5\u021f\1\u023a\27\u021f\2\0\26\u021f\12\0\1\u018a"+
    "\107\0\1\u0113\1\0\1\u023b\25\0\1\u0113\1\0\1\u023b"+
    "\15\0\1\u023c\77\0\1\u023d\30\0\1\u023d\54\0\1\u023e"+
    "\27\0\1\u023e\4\0\2\u0225\2\0\5\u0225\1\u023f\27\u0225"+
    "\2\0\26\u0225\2\u0226\2\0\5\u0226\1\u0240\27\u0226\2\0"+
    "\26\u0226\31\0\1\u0241\27\0\1\u0241\20\0\1\u0242\102\0"+
    "\1\u017f\27\0\1\u017f\30\0\1\u0243\30\0\1\u0243\67\0"+
    "\1\u0244\25\0\2\u022c\2\0\5\u022c\1\u022d\27\u022c\2\0"+
    "\26\u022c\10\0\1\u0245\60\0\2\u022c\2\0\5\u022c\1\u022d"+
    "\1\u022c\1\u0246\25\u022c\2\0\1\u022c\1\u0246\24\u022c\10\0"+
    "\1\u022f\31\0\1\u0247\62\0\1\u0248\27\0\1\u0248\14\0"+
    "\1\u0231\31\0\1\u0249\57\0\1\u024a\27\0\1\u024a\20\0"+
    "\1\u024b\102\0\1\u0188\27\0\1\u0188\30\0\1\u024c\30\0"+
    "\1\u024c\24\0\2\u0236\2\0\5\u0236\1\u0237\27\u0236\2\0"+
    "\26\u0236\10\0\1\u024d\60\0\2\u0236\2\0\5\u0236\1\u0237"+
    "\1\u0236\1\u024e\25\u0236\2\0\1\u0236\1\u024e\24\u0236\10\0"+
    "\1\u0239\31\0\1\u024f\36\0\1\u0250\114\0\1\u0251\27\0"+
    "\1\u0251\14\0\1\u023c\31\0\1\u0252\27\0\2\u023d\1\0"+
    "\1\u0253\2\u023d\32\0\1\u0254\1\0\1\u023d\50\0\1\u0255"+
    "\27\0\1\u0255\25\0\1\u0256\70\0\1\u0257\72\0\1\u01b3"+
    "\103\0\1\u019a\1\u019b\3\0\1\u019c\1\u0258\21\0\1\u019a"+
    "\1\u019b\3\0\1\u019c\1\u0258\41\0\1\u0259\27\0\1\u0259"+
    "\36\0\1\u025a\27\0\1\u025a\16\0\1\u0245\31\0\1\u025b"+
    "\26\0\2\u022c\2\0\5\u022c\1\u022d\14\u022c\1\u025c\12\u022c"+
    "\2\0\13\u022c\1\u025c\12\u022c\41\u025d\1\0\27\u025d\31\0"+
    "\1\u025e\27\0\1\u025e\7\0\41\u025f\1\0\27\u025f\12\0"+
    "\1\u01c0\75\0\1\u01a6\5\0\1\u01a7\1\u01a8\3\0\1\u01a9"+
    "\1\u0260\14\0\1\u01a6\4\0\1\u01a7\1\u01a8\3\0\1\u01a9"+
    "\1\u0260\41\0\1\u0261\27\0\1\u0261\14\0\1\u024d\31\0"+
    "\1\u0262\26\0\2\u0236\2\0\5\u0236\1\u0237\14\u0236\1\u0263"+
    "\12\u0236\2\0\13\u0236\1\u0263\12\u0236\41\u0264\1\0\27\u0264"+
    "\10\0\1\u0250\31\0\1\u0265\57\0\1\u0266\27\0\1\u0266"+
    "\7\0\41\u0267\1\0\27\u0267\27\0\1\u0268\27\0\1\u0268"+
    "\36\0\1\u0269\27\0\1\u0269\43\0\1\u026a\27\0\1\u026a"+
    "\20\0\1\u0256\31\0\1\u026b\36\0\1\u0257\31\0\1\u026c"+
    "\62\0\1\u026d\27\0\1\u026d\23\0\1\u026e\30\0\1\u026e"+
    "\37\0\1\u026f\30\0\1\u026f\20\0\41\u0270\1\0\27\u0270"+
    "\2\u022c\2\0\5\u022c\1\u022d\5\u022c\1\u0271\21\u022c\2\0"+
    "\5\u022c\1\u0271\20\u022c\41\u025d\1\u0272\27\u025d\37\0\1\u0273"+
    "\27\0\1\u0273\1\0\41\u025f\1\u0274\27\u025f\34\0\1\u0275"+
    "\27\0\1\u0275\23\0\1\u0276\30\0\1\u0276\20\0\41\u0277"+
    "\1\0\27\u0277\2\u0236\2\0\5\u0236\1\u0237\5\u0236\1\u0278"+
    "\21\u0236\2\0\5\u0236\1\u0278\20\u0236\41\u0264\1\u0279\27\u0264"+
    "\41\u027a\1\0\27\u027a\37\0\1\u027b\27\0\1\u027b\1\0"+
    "\41\u0267\1\u027c\27\u0267\14\0\1\u027d\30\0\1\u027d\47\0"+
    "\1\u027e\27\0\1\u027e\43\0\1\u027f\27\0\1\u027f\11\0"+
    "\41\u0280\1\0\27\u0280\41\u0281\1\0\27\u0281\31\0\1\u0282"+
    "\27\0\1\u0282\10\0\2\u026e\1\0\1\u0283\2\u026e\32\0"+
    "\1\u0284\1\0\1\u026e\45\0\1\u0285\30\0\1\u0285\17\0"+
    "\41\u0270\1\u0286\27\u0270\2\u022c\2\0\5\u022c\1\u0287\27\u022c"+
    "\2\0\26\u022c\7\0\1\u0288\72\0\1\u0289\66\0\1\u028a"+
    "\112\0\1\u028b\27\0\1\u028b\10\0\2\u0276\1\0\1\u028c"+
    "\2\u0276\32\0\1\u028d\1\0\1\u0276\25\0\41\u0277\1\u028e"+
    "\27\u0277\2\u0236\2\0\5\u0236\1\u028f\27\u0236\2\0\26\u0236"+
    "\7\0\1\u0290\61\0\41\u027a\1\u0291\27\u027a\11\0\1\u0292"+
    "\66\0\1\u0293\114\0\1\u0294\27\0\1\u0294\34\0\1\u0295"+
    "\27\0\1\u0295\22\0\1\u0296\57\0\41\u0280\1\u0297\27\u0280"+
    "\41\u0281\1\u0298\27\u0281\37\0\1\u0299\27\0\1\u0299\30\0"+
    "\1\u029a\27\0\1\u029a\36\0\1\u029b\27\0\1\u029b\24\0"+
    "\1\u029c\66\0\1\u029d\71\0\1\u029e\105\0\1\u029f\27\0"+
    "\1\u029f\13\0\2\u0289\2\0\5\u0289\1\u02a0\27\u0289\2\0"+
    "\26\u0289\25\0\1\u02a1\27\0\1\u02a1\52\0\1\u02a2\27\0"+
    "\1\u02a2\30\0\1\u02a3\27\0\1\u02a3\36\0\1\u02a4\27\0"+
    "\1\u02a4\22\0\1\u02a5\71\0\1\u02a6\105\0\1\u02a7\27\0"+
    "\1\u02a7\22\0\1\u02a8\61\0\2\u0292\2\0\5\u0292\1\u02a9"+
    "\27\u0292\2\0\26\u0292\25\0\1\u02aa\27\0\1\u02aa\44\0"+
    "\1\u02ab\27\0\1\u02ab\20\0\1\u02ac\57\0\2\u0296\2\0"+
    "\5\u0296\1\u02ad\27\u0296\2\0\26\u0296\7\0\1\u02ae\70\0"+
    "\1\u02af\72\0\1\u02b0\73\0\1\u02b1\30\0\1\u02b1\47\0"+
    "\1\u02b2\27\0\1\u02b2\14\0\2\u029c\2\0\5\u029c\1\u02b3"+
    "\27\u029c\2\0\26\u029c\25\0\1\u02b4\27\0\1\u02b4\23\0"+
    "\1\u029e\31\0\1\u02b5\52\0\1\u02b6\27\0\1\u02b6\24\0"+
    "\1\u02b7\104\0\1\u02b8\27\0\1\u02b8\25\0\1\u02b9\73\0"+
    "\1\u02ba\30\0\1\u02ba\47\0\1\u02bb\27\0\1\u02bb\41\0"+
    "\1\u02bc\27\0\1\u02bc\23\0\1\u02a6\31\0\1\u02bd\52\0"+
    "\1\u02be\27\0\1\u02be\41\0\1\u02bf\27\0\1\u02bf\23\0"+
    "\1\u02c0\104\0\1\u02c1\27\0\1\u02c1\26\0\1\u023d\107\0"+
    "\1\u01af\1\0\1\u02c2\25\0\1\u01af\1\0\1\u02c2\15\0"+
    "\1\u02c3\105\0\1\u02c4\27\0\1\u02c4\40\0\1\u02c5\27\0"+
    "\1\u02c5\13\0\2\u02b0\2\0\5\u02b0\1\u02c6\27\u02b0\2\0"+
    "\26\u02b0\33\0\1\u02c7\27\0\1\u02c7\34\0\1\u02c8\27\0"+
    "\1\u02c8\21\0\1\u02c9\104\0\1\u02ca\27\0\1\u02ca\14\0"+
    "\41\u02cb\1\0\27\u02cb\27\0\1\u02cc\27\0\1\u02cc\21\0"+
    "\1\u02b7\31\0\1\u02cd\55\0\1\u02ce\27\0\1\u02ce\11\0"+
    "\2\u02b9\2\0\5\u02b9\1\u02cf\27\u02b9\2\0\26\u02b9\33\0"+
    "\1\u02d0\27\0\1\u02d0\34\0\1\u02d1\27\0\1\u02d1\35\0"+
    "\1\u02d2\27\0\1\u02d2\14\0\41\u02d3\1\0\27\u02d3\27\0"+
    "\1\u02d4\27\0\1\u02d4\35\0\1\u02d5\27\0\1\u02d5\24\0"+
    "\1\u02c0\31\0\1\u02d6\55\0\1\u02d7\27\0\1\u02d7\45\0"+
    "\1\u02d8\27\0\1\u02d8\14\0\1\u02c3\31\0\1\u02d9\52\0"+
    "\1\u02da\27\0\1\u02da\40\0\1\u02db\27\0\1\u02db\24\0"+
    "\1\u02dc\111\0\1\u02dd\27\0\1\u02dd\20\0\1\u02de\67\0"+
    "\1\u02c9\31\0\1\u02df\55\0\1\u02e0\27\0\1\u02e0\11\0"+
    "\41\u02cb\1\u02e1\27\u02cb\42\0\1\u02e2\26\0\41\u02e3\1\0"+
    "\27\u02e3\42\0\1\u02e4\36\0\1\u02e5\111\0\1\u02e6\27\0"+
    "\1\u02e6\20\0\1\u02e7\106\0\1\u02e8\27\0\1\u02e8\11\0"+
    "\41\u02d3\1\u02e9\27\u02d3\42\0\1\u02ea\55\0\1\u02eb\27\0"+
    "\1\u02eb\11\0\41\u02ec\1\0\27\u02ec\42\0\1\u02ed\57\0"+
    "\1\u02ee\27\0\1\u02ee\7\0\41\u02ef\1\0\27\u02ef\27\0"+
    "\1\u02f0\27\0\1\u02f0\40\0\1\u02f1\27\0\1\u02f1\21\0"+
    "\1\u02dc\31\0\1\u02f2\40\0\1\u026e\103\0\1\u019a\1\u019b"+
    "\3\0\1\u019c\1\u02f3\21\0\1\u019a\1\u019b\3\0\1\u019c"+
    "\1\u02f3\5\0\41\u02f4\1\0\27\u02f4\42\0\1\u02f5\35\0"+
    "\1\u02f6\61\0\41\u02e3\1\u02f7\27\u02e3\1\0\2\u02f8\1\0"+
    "\1\u02f9\1\0\1\u02f8\2\0\2\u02f8\17\0\1\u02fa\6\0"+
    "\1\u02fb\1\0\1\u02f8\16\0\1\u02fa\16\0\1\u02e5\31\0"+
    "\1\u02fc\40\0\1\u0276\75\0\1\u01a6\5\0\1\u01a7\1\u01a8"+
    "\3\0\1\u01a9\1\u02fd\14\0\1\u01a6\4\0\1\u01a7\1\u01a8"+
    "\3\0\1\u01a9\1\u02fd\47\0\1\u02fe\35\0\1\u02ff\123\0"+
    "\1\u0121\26\0\41\u02ec\1\u0300\27\u02ec\37\0\1\u0301\27\0"+
    "\1\u0301\1\0\41\u02ef\1\u0302\27\u02ef\42\0\1\u0117\70\0"+
    "\1\u0118\26\0\41\u0303\1\0\27\u0303\34\0\1\u0304\27\0"+
    "\1\u0304\4\0\41\u02f4\1\u0305\27\u02f4\1\0\2\u02f5\1\0"+
    "\1\u0306\2\u02f5\32\0\1\u0307\1\0\1\u02f5\52\0\1\u0308"+
    "\27\0\1\u0308\22\0\1\u0309\110\0\1\u030a\27\0\1\u030a"+
    "\30\0\1\u030b\30\0\1\u030b\45\0\1\u030c\27\0\1\u030c"+
    "\13\0\41\u030d\1\0\27\u030d\34\0\1\u030e\27\0\1\u030e"+
    "\5\0\2\u02fe\1\0\1\u030f\2\u02fe\32\0\1\u0310\1\0"+
    "\1\u02fe\52\0\1\u0311\27\0\1\u0311\22\0\1\u0312\72\0"+
    "\1\u0313\66\0\1\u0314\61\0\41\u0303\1\u0315\27\u0303\31\0"+
    "\1\u0316\27\0\1\u0316\16\0\1\u0317\110\0\1\u0318\27\0"+
    "\1\u0318\36\0\1\u0319\27\0\1\u0319\37\0\1\u031a\27\0"+
    "\1\u031a\41\0\1\u031b\27\0\1\u031b\27\0\1\u031c\30\0"+
    "\1\u031c\50\0\1\u031d\27\0\1\u031d\37\0\1\u031e\27\0"+
    "\1\u031e\14\0\41\u030d\1\u031f\27\u030d\31\0\1\u0320\27\0"+
    "\1\u0320\36\0\1\u0321\27\0\1\u0321\36\0\1\u0322\27\0"+
    "\1\u0322\37\0\1\u0323\27\0\1\u0323\41\0\1\u0324\27\0"+
    "\1\u0324\13\0\2\u0313\2\0\5\u0313\1\u0325\27\u0313\2\0"+
    "\26\u0313\25\0\1\u0326\27\0\1\u0326\22\0\1\u0327\120\0"+
    "\1\u0328\27\0\1\u0328\26\0\1\u0329\27\0\1\u0329\27\0"+
    "\1\u032a\30\0\1\u032a\47\0\1\u032b\27\0\1\u032b\43\0"+
    "\1\u032c\27\0\1\u032c\35\0\1\u032d\27\0\1\u032d\47\0"+
    "\1\u032e\27\0\1\u032e\20\0\1\u032f\30\0\1\u032f\53\0"+
    "\1\u0330\27\0\1\u0330\20\0\1\u0331\120\0\1\u0332\27\0"+
    "\1\u0332\15\0\1\u0333\30\0\1\u0333\47\0\1\u0334\27\0"+
    "\1\u0334\43\0\1\u0335\27\0\1\u0335\35\0\1\u0336\27\0"+
    "\1\u0336\24\0\1\u0337\104\0\1\u0338\27\0\1\u0338\41\0"+
    "\1\u0339\27\0\1\u0339\24\0\1\u033a\103\0\1\u033b\27\0"+
    "\1\u033b\47\0\1\u033c\27\0\1\u033c\34\0\1\u033d\27\0"+
    "\1\u033d\53\0\1\u033e\55\0\1\u033f\27\0\1\u033f\42\0"+
    "\1\u0340\27\0\1\u0340\47\0\1\u0341\27\0\1\u0341\11\0"+
    "\1\u0342\104\0\1\u0343\27\0\1\u0343\24\0\1\u0344\112\0"+
    "\1\u0345\27\0\1\u0345\34\0\1\u0346\27\0\1\u0346\53\0"+
    "\1\u0347\55\0\1\u0348\27\0\1\u0348\21\0\1\u0337\31\0"+
    "\1\u0349\55\0\1\u034a\27\0\1\u034a\35\0\1\u034b\27\0"+
    "\1\u034b\14\0\2\u033a\2\0\5\u033a\1\u034c\27\u033a\2\0"+
    "\26\u033a\27\0\1\u034d\27\0\1\u034d\42\0\1\u034e\27\0"+
    "\1\u034e\20\0\1\u034f\60\0\2\u033e\1\0\1\u0350\2\u033e"+
    "\32\0\1\u0351\1\0\1\u033e\67\0\1\u0182\40\0\1\u02f8"+
    "\101\0\1\u0352\27\0\1\u0352\46\0\1\u010e\1\0\1\u0353"+
    "\25\0\1\u010e\1\0\1\u0353\31\0\1\u0354\27\0\1\u0354"+
    "\14\0\2\u0344\2\0\5\u0344\1\u0355\27\u0344\2\0\26\u0344"+
    "\31\0\1\u0356\27\0\1\u0356\20\0\1\u0357\60\0\2\u0347"+
    "\1\0\1\u0358\2\u0347\32\0\1\u0359\1\0\1\u0347\67\0"+
    "\1\u018a\26\0\41\u035a\1\0\27\u035a\42\0\1\u035b\55\0"+
    "\1\u035c\27\0\1\u035c\21\0\1\u035d\122\0\1\u035e\40\0"+
    "\1\u02f5\103\0\1\u019a\4\0\1\u019c\1\u035f\21\0\1\u019a"+
    "\4\0\1\u019c\1\u035f\34\0\1\u0360\27\0\1\u0360\36\0"+
    "\1\u0361\27\0\1\u0361\43\0\1\u0362\27\0\1\u0362\44\0"+
    "\1\u0363\27\0\1\u0363\33\0\1\u0364\27\0\1\u0364\21\0"+
    "\1\u0365\72\0\1\u02fe\75\0\1\u01a6\5\0\1\u01a7\4\0"+
    "\1\u01a9\1\u0366\14\0\1\u01a6\4\0\1\u01a7\4\0\1\u01a9"+
    "\1\u0366\34\0\1\u0367\27\0\1\u0367\36\0\1\u0368\27\0"+
    "\1\u0368\13\0\41\u035a\1\u0369\27\u035a\1\0\2\u036a\1\0"+
    "\1\u036b\1\0\1\u036a\2\0\2\u036a\17\0\1\u036c\6\0"+
    "\1\u036d\1\0\1\u036a\16\0\1\u036c\50\0\1\u01b3\36\0"+
    "\1\u035d\31\0\1\u036e\62\0\1\u036f\27\0\1\u036f\20\0"+
    "\1\u0370\30\0\1\u0370\47\0\1\u0371\27\0\1\u0371\43\0"+
    "\1\u0372\27\0\1\u0372\42\0\1\u0373\27\0\1\u0373\51\0"+
    "\1\u01c0\36\0\1\u0365\31\0\1\u0374\62\0\1\u0375\27\0"+
    "\1\u0375\20\0\1\u0376\30\0\1\u0376\47\0\1\u0377\27\0"+
    "\1\u0377\23\0\1\u0378\110\0\1\u0379\27\0\1\u0379\30\0"+
    "\1\u037a\30\0\1\u037a\45\0\1\u037b\27\0\1\u037b\13\0"+
    "\41\u037c\1\0\27\u037c\31\0\1\u037d\27\0\1\u037d\42\0"+
    "\1\u037e\27\0\1\u037e\34\0\1\u037f\27\0\1\u037f\30\0"+
    "\1\u02f8\30\0\1\u02f8\57\0\1\u0380\27\0\1\u0380\1\0"+
    "\41\u0381\1\0\27\u0381\31\0\1\u0382\27\0\1\u0382\42\0"+
    "\1\u0383\27\0\1\u0383\34\0\1\u0384\27\0\1\u0384\36\0"+
    "\1\u0385\27\0\1\u0385\27\0\1\u0386\30\0\1\u0386\50\0"+
    "\1\u0387\27\0\1\u0387\37\0\1\u0388\27\0\1\u0388\14\0"+
    "\41\u037c\1\u0389\27\u037c\37\0\1\u038a\27\0\1\u038a\32\0"+
    "\1\u038b\27\0\1\u038b\20\0\1\u038c\70\0\1\u038d\57\0"+
    "\41\u0381\1\u038e\27\u0381\37\0\1\u038f\27\0\1\u038f\32\0"+
    "\1\u0390\27\0\1\u0390\20\0\1\u0391\103\0\1\u0392\27\0"+
    "\1\u0392\47\0\1\u0393\27\0\1\u0393\20\0\1\u0394\30\0"+
    "\1\u0394\53\0\1\u0395\27\0\1\u0395\20\0\1\u0396\72\0"+
    "\1\u022c\71\0\1\u033e\103\0\1\u019a\1\u0397\3\0\1\u019c"+
    "\1\u0398\21\0\1\u019a\1\u0397\3\0\1\u019c\1\u0398\5\0"+
    "\2\u038d\2\0\5\u038d\1\u0399\27\u038d\2\0\26\u038d\7\0"+
    "\1\u039a\72\0\1\u0236\71\0\1\u0347\75\0\1\u01a6\5\0"+
    "\1\u01a7\1\u039b\3\0\1\u01a9\1\u039c\14\0\1\u01a6\4\0"+
    "\1\u01a7\1\u039b\3\0\1\u01a9\1\u039c\34\0\1\u039d\27\0"+
    "\1\u039d\42\0\1\u039e\27\0\1\u039e\47\0\1\u039f\27\0"+
    "\1\u039f\11\0\1\u03a0\104\0\1\u03a1\27\0\1\u03a1\36\0"+
    "\1\u03a2\27\0\1\u03a2\51\0\1\u03a3\27\0\1\u03a3\14\0"+
    "\1\u03a4\105\0\1\u03a5\27\0\1\u03a5\36\0\1\u03a6\27\0"+
    "\1\u03a6\51\0\1\u03a7\27\0\1\u03a7\46\0\1\u023d\40\0"+
    "\1\u036a\101\0\1\u03a8\27\0\1\u03a8\46\0\1\u01af\1\0"+
    "\1\u03a9\25\0\1\u01af\1\0\1\u03a9\31\0\1\u03aa\27\0"+
    "\1\u03aa\47\0\1\u03ab\27\0\1\u03ab\36\0\1\u03ac\27\0"+
    "\1\u03ac\17\0\1\u03a4\31\0\1\u03ad\52\0\1\u03ae\27\0"+
    "\1\u03ae\47\0\1\u03af\27\0\1\u03af\36\0\1\u03b0\27\0"+
    "\1\u03b0\37\0\1\u03b1\27\0\1\u03b1\44\0\1\u03b2\27\0"+
    "\1\u03b2\33\0\1\u03b3\27\0\1\u03b3\26\0\1\u038a\30\0"+
    "\1\u038a\61\0\1\u03b4\27\0\1\u03b4\1\0\41\u03b5\1\0"+
    "\27\u03b5\27\0\1\u03b6\27\0\1\u03b6\26\0\1\u038f\30\0"+
    "\1\u038f\61\0\1\u03b7\27\0\1\u03b7\30\0\1\u03b8\27\0"+
    "\1\u03b8\42\0\1\u03b9\27\0\1\u03b9\51\0\1\u026e\37\0"+
    "\1\u03ba\57\0\41\u03b5\1\u03bb\27\u03b5\42\0\1\u0276\37\0"+
    "\1\u03bc\76\0\1\u036a\30\0\1\u036a\57\0\1\u03bd\27\0"+
    "\1\u03bd\1\0\2\u03ba\2\0\5\u03ba\1\u0287\27\u03ba\2\0"+
    "\26\u03ba\7\0\1\u03be\61\0\2\u03bc\2\0\5\u03bc\1\u028f"+
    "\27\u03bc\2\0\26\u03bc\11\0\1\u03bf\104\0\1\u03c0\27\0"+
    "\1\u03c0\13\0\2\u03bf\2\0\5\u03bf\1\u03c1\27\u03bf\2\0"+
    "\26\u03bf\24\0\1\u03c2\27\0\1\u03c2\24\0\1\u03c3\107\0"+
    "\1\u03c4\27\0\1\u03c4\21\0\1\u03c3\31\0\1\u03c5\70\0"+
    "\1\u02f8\26\0\41\u03c6\1\0\70\u03c6\1\u03c7\27\u03c6\7\0"+
    "\1\u03c8\106\0\1\u03c9\27\0\1\u03c9\37\0\1\u03ca\27\0"+
    "\1\u03ca\43\0\1\u03cb\27\0\1\u03cb\53\0\1\u036a\26\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[54378];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\4\0\1\11\1\1\1\11\1\1\1\11\2\1\15\0"+
    "\1\11\120\0\1\11\36\0\1\1\71\0\1\11\6\0"+
    "\1\1\6\0\1\1\5\0\1\1\70\0\1\1\1\11"+
    "\u01d0\0\1\11\1\0\1\1\5\0\1\11\2\0\1\11"+
    "\155\0\1\1\2\0\1\11\155\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[971];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S208_AddPartitionsToReferences() { }
	
	private String context = "";
	
	private AnnotationEntity retrievedReference = null;
	
	boolean isEuropeanReference = false;

	private void readReference() {
	
		String name = "[LKN:LEG_REF:";
		int start = yytext().indexOf(name);
		
		if(start == -1) {
			
			name = "[LKN:EU_LEG_REF:";
			start = yytext().indexOf(name);
		}
	
		if(start == -1) {
			
			name = "[LKN:REF:";
			start = yytext().indexOf(name);
		}
	
		retrievedReference = retrieveEntity(yytext().substring(start));
	}

	private AnnotationEntity readPartition() {
	
		//String name = "[LKN:LEG_PARTITION:";
		String name = "[LKN:PARTITION:";
		int start = yytext().indexOf(name);
		
		return retrieveEntity(yytext().substring(start));
	}
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S208_AddPartitionsToReferences(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 14: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 15: break;
          case 3:
            { checkEnd();
            }
          // fall through
          case 16: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 17: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 18: break;
          case 6:
            { if( !checkEdge()) {
		
			addText();
			offset += yylength();
		}
            }
          // fall through
          case 19: break;
          case 7:
            { AnnotationEntity retrievedPartition = retrieveEntity();
		
		Reference legRef = new Reference(Entity.LEG_REF);
		if(isEuropeanReference) legRef = new Reference(Entity.EU_LEG_REF);
		legRef.setPosition(retrievedPartition.getPosition());
		legRef.setText(retrievedPartition.getText());
		legRef.setContext(context);
		
		for(AnnotationEntity relEnt : retrievedReference.getRelatedEntities()) {
		
			legRef.addRelatedEntity(relEnt);
			//Non aggiungere l'inversa altrimenti viene sovrascritta la reference originale?
		}
	
		legRef.addRelatedEntity(retrievedPartition);
		retrievedPartition.addRelatedEntity(legRef);
		
		addEntity(legRef);
	
		offset += yylength();
            }
          // fall through
          case 20: break;
          case 8:
            { //System.out.println("AddPartToRef pattern1: " + yytext());
	
	context = Util.removeAllAnnotations(yytext());

	isEuropeanReference = false;
	retrievedReference = null;
	readReference();
	((Reference) retrievedReference).setContext(context);
	offset = 0;
	length = yylength();
	yypushback(length);
	yybegin(convertPartitionAscState);
            }
          // fall through
          case 21: break;
          case 9:
            { //System.out.println("AddPartToRef pattern2: " + yytext());
	
	context = Util.removeAllAnnotations(yytext());
	
	isEuropeanReference = false;
	retrievedReference = null;
	
	readReference();

	if(retrievedReference.getRelatedEntity(Entity.PARTITION) != null) {
		
		//il riferimento ha già una partition associata, saltalo
		
		addText();
		
		yybegin(0);
	
	} else {
	
		((Reference) retrievedReference).setContext(context);
		offset = 0;
		length = yylength();
		yypushback(length);
		yybegin(convertPartitionDescState);
	}
            }
          // fall through
          case 22: break;
          case 10:
            { AnnotationEntity retrievedPartition = retrieveEntity();
		
		//Aggiorna la precedente annotazione Reference
		retrievedReference.setPosition(retrievedPartition.getPosition());
		retrievedReference.setText(Util.removeAllAnnotations(yytext()));
		
		retrievedReference.addRelatedEntity(retrievedPartition);
		retrievedPartition.addRelatedEntity(retrievedReference);
		
		addEntity(retrievedReference);
		
		offset += yylength();
            }
          // fall through
          case 23: break;
          case 11:
            { AnnotationEntity retrievedPartition = readPartition();
		
		//Aggiorna la precedente annotazione Reference
		retrievedReference.setText(Util.removeAllAnnotations(yytext()));
		
		retrievedReference.addRelatedEntity(retrievedPartition);
		retrievedPartition.addRelatedEntity(retrievedReference);
		
		addEntity(retrievedReference);
		
		offset += yylength();
            }
          // fall through
          case 24: break;
          case 12:
            { //System.out.println("AddPartToRef pattern3: " + yytext());
	
	context = Util.removeAllAnnotations(yytext());
	
	isEuropeanReference = true;
	retrievedReference = null;
	readReference();
	((Reference) retrievedReference).setContext(context);
	offset = 0;
	length = yylength();
	yypushback(length);
	yybegin(convertPartitionDescState);
            }
          // fall through
          case 25: break;
          case 13:
            { context = Util.removeAllAnnotations(yytext());
	
	isEuropeanReference = true;
	retrievedReference = null;
	readReference();
	((Reference) retrievedReference).setContext(context);
	offset = 0;
	length = yylength();
	yypushback(length);
	yybegin(convertPartitionAscState);
            }
          // fall through
          case 26: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S208_AddPartitionsToReferences [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S208_AddPartitionsToReferences scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S208_AddPartitionsToReferences(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
